import daemon
import os
import boto.ec2
from boto.ec2.connection import EC2Connection
from boto.manage.cmdshell import sshclient_from_instance
import time
import datetime
RUNNINGMACHINES = {}

def _get_account_image_ids(conn):
    available_images = conn.get_all_images(owners='self')
    image_ids = {}
    for image in available_images:
        image_ids[image.name] = image.id
    return image_ids

def checkCloud():
	while True:
		with open("/tmp/clouddaemon.txt","w") as f:
			f.write("clouddaemon log " + time.ctime() + "\n")		
	       		f.write(checkRunningMachines())
			f.write(terminateLongRunningMachines()) 
		time.sleep(60);
def checkRunningMachines():
	return_string = ""
 	RUNNINGMACHINES.clear()	
	hardcoded_access_key_id="XXXX" 
	hardcoded_secret_access_key='xxxx'
	region = "us-east-1"#
	DEFAULT_AMI_ID = "ami-f6562c9e"#
	ami_id = DEFAULT_AMI_ID

	conn = boto.ec2.connect_to_region(region,
    	aws_access_key_id=hardcoded_access_key_id,
    	aws_secret_access_key=hardcoded_secret_access_key)
        print "Connected to AWS\n"	
	reservations = conn.get_all_reservations()
	print "Got all reservations\n"
	instance_ips = []
	account_image_ids = _get_account_image_ids(conn)
	for reservation in reservations:
    		for running in reservation.instances:
        		instance_ips.append(running.ip_address)
        		if running is not None and running.ip_address is not None:
            			image_name = conn.get_image(running.image_id).name

				RUNNINGMACHINES[running.ip_address] = ["underutilized",running,datetime.datetime.utcnow() - datetime.datetime.strptime(running.launch_time.replace("T"," ").replace("Z","")[:-4],'%Y-%m-%d %H:%M:%S')] 
				return_string += 'Instance IP ' + running.ip_address + ' is running AMI ' + image_name +' for ' + str(RUNNINGMACHINES[running.ip_address][2])  + ' since ' + str(running.launch_time) + '\n'
	
	return "no instaces running" if return_string == "" else return_string 	
def terminateLongRunningMachines():
	return_string = ""
	for ip in RUNNINGMACHINES.keys():
	        element = RUNNINGMACHINES[ip] 
		if (element[2].total_seconds() > 3 * 60 * 60):
       		        element[1].terminate();	
			return_string += "Terminated machine " + ip + "\n" 
	return "Terminated 0 machines" if (return_string == "") else return_string			 	
	
def run():
	with daemon.DaemonContext():
		checkCloud()	
if __name__ == "__main__":
	run()
	#print checkRunningMachines()
	#print terminateLongRunningMachines() 
